function synchronizePromise(fun) {
  var lastPromise;
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    lastPromise = lastPromise ? lastPromise.catch(function () {}).then(function () {
      return fun.apply(void 0, args);
    }) : fun.apply(void 0, args);
    return lastPromise;
  };
}

export default synchronizePromise;
