'use strict';

function synchronizePromise(fun) {
  let lastPromise;
  return (...args) => {
    lastPromise = lastPromise ? lastPromise.catch(() => {}).then(() => fun(...args)) : fun(...args);
    return lastPromise;
  };
}

module.exports = synchronizePromise;
